<!DOCTYPE html>
<html lang="en" ng-app="app" ng-controller="UserCtrl">
<head>
    <!-- Tämän tiedoston tulee sijaita client kansion ulkopuolella, ettei siihen pääse käsiksi ilman sisäänkirjautumista.
    Sisällytetään kirjastot.
    Sovellus käyttää tiedostojen sijaintina client kansiota, siksi linkit toimivat. -->
    <!-- Tyylit -->
    <link rel="stylesheet" href="bootstrap.min.css">
    <link rel="stylesheet" href="style.css">
    <!-- Jquery, Angular ja bootstrap-->
    <script src="jquery.min.js"></script>
    <script src="angular.min.js"></script>
    <script src="bootstrap.min.js"></script>
    <!-- app/controllers -->
    <script src="controllers/userCtrl.js"></script>
    <script src="controllers/chatCtrl.js"></script>
    <script src="controllers/playersCtrl.js"></script>
    <script src="controllers/gameCtrl.js"></script>
    <script src="controllers/scoreCtrl.js"></script>

    <!-- Use vue/socket on gameboard -->
    <script src="socket.io.js"></script>
    <script src="https://unpkg.com/vue/dist/vue.js"></script>
    <!-- Meta data -->
    <meta charset="utf-8">
    <link rel="icon"
          type="image/ico"
          href="favicon.ico">
    <title>webkompor2</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style>
        /* Tyylittelyä kankaan kokoruutuun saamiseksi */
        canvas {
            background-color: lightblue;
            /* Position voi vaikuttaa hiiren sijaintiin, display block poistanee scroll baarit. */
            position: relative;
        }
        html, body {
            overflow: hidden;
            width:100%; height:100%;
        }
        /* to remove the top and left whitespace */
        * { margin:0; padding:0; }
    </style>
</head>
<body>
<div class="container-fluid">
    <!-- Pelin toteutuksessa käytetty vue:ta, scoret ym angularin avulla. -->
    <div id="vueapp" ng-controller="GameCtrl">
        <div id="gameboard">
            <canvas ref="canvas" @mousemove="moveBubble" id="canvas" :width="width" :height="height"></canvas>
        </div>
    </div>
    <div class="row">
        <div style="position: absolute; left: 20px; top: 10px; color: white; background-color: rgba(0, 0, 0,0);">
            <h2>Top ten</h2>
            <div id="leaderboard" style="font-size: 120%; padding-left: 10px;">
                <!-- Leaderboard haetaan tähän. -->
            </div>
        </div>
        <div style="position: absolute; right: 30px; top: 10px; color: white; background-color: rgba(0, 0, 0,0)">
            <h2>Player list</h2>
            <div style="font-size: 120%;" ng-controller="PlayersCtrl" id="online_players">
                <!-- Player list tulostetaan tähän -->
            </div>
        </div>
    </div>
    <div ng-controller="ChatCtrl">
        <div id="chat_log_area" style="position: absolute; left: 10px; bottom: 50px; height: 25%; width: 100%; min-width: 150px;
        max-width: 500px; overflow-y: scroll; word-wrap: break-word; padding: 10px; background-color: rgba(234, 229, 229, 0.7);">
            <div id="chat_log">
                <!-- Viestit haetaan tähän -->
            </div>
        </div>
            <!-- Chat input -->
            <div id="chat_input" style="position: absolute; left: 10px; bottom: 10px; width: 100%;
            min-width: 150px; max-width: 500px;">
                <form name="ChatForm" ng-submit="submitChatForm(ChatForm.$valid)" novalidate>
                    <br><br>
                    <div class="input-group" ng-class="{ 'has-error' : ChatForm.chat_message.$invalid &&
                         !ChatForm.chat_message.$pristine }">
                        <input id="chat_message" name="chat_message" class="form-control" ng-model="user.chat_message"
                               maxlength="140" required>
                        <span class="input-group-btn">
                        <button class="btn btn-default" type="submit">Lähetä</button>
                        </span>
                    </div>
                </form>
            </div>
    </div>
    <div style="text-align: right;position: absolute; right: 20px; bottom: 15px;
         background-color: rgba(234, 229, 229,0.0);">
        <button type="button" class="btn btn-info" ng-click="load_user_data()"
                onclick= open_user_popup()>Omat tiedot</button>
        <button type="button" class="btn btn-danger" style="float: right;" ng-click="logout()">Kirjaudu ulos</button>
        <button ng-controller="ScoreCtrl" type="button" class="btn btn-warning" style="float: right;"
                ng-click="end_game()">Uusi peli</button>
    </div>
    <!-- Nickin ja salasanan muokkaus. -->
    <div id="UserPopup" class="modal fade" role="dialog" data-backdrop="static">
        <!-- Modal content -->
        <div class="modal-content container-fluid">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span></button>
                <h2 style="text-align: center;">Tilin tiedot</h2>
            </div>
            <div class="modal-body">
                <form name="NicknameForm" ng-submit="submitNicknameForm(NicknameForm.$valid)" novalidate>
                    <br><br>
                    <!-- email -->
                    <div class="form-group">
                        <label>Sähköpostiosoite</label>
                        <input type="email" id="user_email" name="user_email" class="form-control" ng-model="user.user_email"
                               maxlength="60" disabled>
                    </div>
                    <!-- nickname -->
                    <div class="form-group" ng-class="{ 'has-error' : NicknameForm.user_username.$invalid &&
                    !NicknameForm.user_username.$pristine }">
                        <label>Käyttäjänimi</label>
                        <input id="user_username" name="user_username" class="form-control" ng-model="user.user_username"
                               maxlength="40" required placeholder="*">
                        <p ng-show="NicknameForm.user_username.$invalid && !NicknameForm.user_username.$pristine"
                           class="help-block">Käyttäjänimi on virheellinen</p>
                    </div>
                    <button type="submit" class="btn btn-success">Tallena käyttäjänimi</button>
                </form>
                <br>
                    <br><strong>Näytä salasanan muokkaus: </strong>
                    <input type="checkbox" name="enable_password_edit"
                           value="checkbox" onchange="ShowPasswordManagement('PasswordEdit')"/>
                    <br>
                    <div id="PasswordEdit" style="display:none;">
                        <br>
                        <form name="PasswordForm" ng-submit="submitPasswordForm(PasswordForm.$valid)" novalidate>
                            <!-- salasanat -->
                            <div class="form-group" ng-class="{ 'has-error' : PasswordForm.current_pass.$invalid &&
                            !PasswordForm.current_pass.$pristine }">
                                <label>Salasana</label>
                                <input type="password" name="current_pass" class="form-control" ng-model="user.current_pass"
                                       ng-minlength="6" required placeholder="*">
                                <p ng-show="PasswordForm.current_pass.$invalid && !PasswordForm.current_pass.$pristine"
                                   class="help-block">Salasanat ovat vähintään 6 merkkiä pitkiä ja sisältävät numeron ja kirjaimen.</p>
                            </div>
                            <!-- TO DO: Salasanojen tarkistus syöttämisen aikana -->
                            <div class="form-group" ng-class="{ 'has-error' : PasswordForm.new_pass.$invalid &&
                            !PasswordForm.new_pass.$pristine }">
                                <label>Uusi salasana</label>
                                <input type="password" name="new_pass" class="form-control"
                                       ng-model="user.new_pass"
                                       ng-minlength="6" required placeholder="*">
                                <p ng-show="PasswordForm.new_pass.$invalid && !PasswordForm.new_pass.$pristine"
                                   class="help-block">Salasanan on oltava vähintään 6 merkkiä pitkä ja sisällettävä
                                    numero ja iso kirjain.</p>
                            </div>
                            <div class="form-group" ng-class="{ 'has-error' : PasswordForm.confirm_new_pass.$invalid &&
                            !PasswordForm.confirm_new_pass.$pristine }">
                                <label>Vahvista uusi salasana</label>
                                <input type="password" name="confirm_new_pass" class="form-control"
                                       ng-model="user.confirm_new_pass"
                                       ng-minlength="6" required placeholder="*">
                            </div>
                            <br>
                            <button type="submit" class="btn btn-success">Vaihda salasana</button>
                        </form>
                    </div>
                    <button ng-click="resetForms()" class="btn btn-info btn-lg" style="float: right" data-dismiss="modal"
                    >Sulje</button>
                    <br><br><br><br>
            </div>
        </div>
    </div>
</div>

<script>
    // Talletetaan chat_log ja leaderboard divien tyhjä muoto, näin se voidaan nollata aina ennen chätin päivitystä.
    $(document).ready(function() {
        $('#chat_log').data('old-state', $('#chat_log').html());
        $('#leaderboard').data('old-state', $('#leaderboard').html());
        $('#online_players').data('old-state', $('#online_players').html());
    });

    // Formin resetointi modaalia suljettaessa.
    $('[data-dismiss=modal]').on('click', function (e) {
        var $t = $(this),
            target = $t[0].href || $t.data("target") || $t.parents('.modal') || [];

        $(target)
            .find("input,textarea,select")
            .val('')
            .end();
    });

    function open_user_popup() {
        $('#UserPopup').modal('show');
    }

    function ShowPasswordManagement(box){
        var chboxs = document.getElementById("PasswordEdit").style.display;
        var vis = "none";
        if(chboxs=="none"){
            vis = "block"; }
        if(chboxs=="block"){
            vis = "none"; }
        document.getElementById(box).style.display = vis;
    }
</script>
</body>
</html>
